package com.njcn.csdevice.service;


import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.IService;
import com.njcn.csdevice.param.IcdNodeParam;
import com.njcn.csdevice.pojo.param.NodeParam;
import com.njcn.csdevice.pojo.po.Node;
import com.njcn.csdevice.pojo.vo.NodeProcessDeviceVo;
import org.springframework.web.bind.annotation.RequestParam;

import java.util.List;

/**
 * <p>
 *  服务类
 * </p>
 *
 * @author cdf
 * @since 2022-01-07
 */
public interface INodeService extends IService<Node> {


    /**
     * 新增前置机
     * @author cdf
     * @date 2021/6/23
     */
    boolean addNode(NodeParam nodeParam);

    /**
     * 修改前置机
     * @author cdf
     * @date 2021/6/23
     */
    boolean updateNode(NodeParam.NodeUpdateParam nodeParam);

    /**
     * 删除前置机
     * @author cdf
     * @date 2021/6/23
     */
    boolean delNode(String id);

    /**
     * 修改前置机状态
     * @author cdf
     * @date 2021/6/23
     */
    boolean updateNodeState(String id, Integer state);

    /**
     * 查询前置机列表
     * @author cdf
     * @date 2021/6/23
     */
    Page<Node> nodeList(NodeParam.NodeQueryParam nodeQueryParam);

    /**
     * 查询前置机列表不分页
     * @author cdf
     * @date 2021/6/23
     */
    List<Node> nodeAllList();

    /**
     * 根据前置机id获取前置机
     * @author cdf
     * @date 2021/6/23
     */
    Node getNodeById(String id);

    /**
     * 根据前置机名称获取详细信息
     * @param nodeName 前置机名称
     * @return 前置信息
     */
    Node getNodeByNodeName(String nodeName);

    Node getNodeByIp(String ip);

    NodeProcessDeviceVo getProcessNoAndDeviceById(String id);

    void restartProcess(String nodeId, Integer processNo);

    String updateDevProcessNo(String id, Integer processNo);

    String updateDevNode(IcdNodeParam param);
}
